# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.1
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal, TYPE_CHECKING

from humanloop.type.chat_message_with_tool_call import ChatMessageWithToolCall
from humanloop.type.update_datapoint_request_inputs import UpdateDatapointRequestInputs
from humanloop.type.update_datapoint_request_target import UpdateDatapointRequestTarget

class RequiredUpdateDatapointRequest(TypedDict):
    pass

class OptionalUpdateDatapointRequest(TypedDict, total=False):
    inputs: UpdateDatapointRequestInputs

    # The chat messages for this datapoint.
    messages: typing.List[ChatMessageWithToolCall]

    target: UpdateDatapointRequestTarget

class UpdateDatapointRequest(RequiredUpdateDatapointRequest, OptionalUpdateDatapointRequest):
    pass
